-- ESEGUITO 2019-06-30
DROP TABLE IF EXISTS PERF_RICONC_MV;
DROP PROCEDURE IF EXISTS REFRESH_PERF_RICONC_MV_NOW;
DELIMITER $$
CREATE PROCEDURE REFRESH_PERF_RICONC_MV_NOW()
BEGIN
    CREATE TABLE IF NOT EXISTS PERF_RICONC_MV
    (
        `ID_PERF_RICONC_MV`      BIGINT(20) NOT NULL auto_increment PRIMARY KEY,
        `SEDE`                   VARCHAR(50)     DEFAULT NULL,
        `AGENZIA`                VARCHAR(50)     DEFAULT NULL,
        `SEPRAG`                 VARCHAR(10)     DEFAULT NULL,
        `PERIODO`                BIGINT(22) NOT NULL,
        `NUMERO_FATTURA`         VARCHAR(20)     DEFAULT NULL,
        `DATA_CONTABILE_FATTURA` DATETIME   NOT NULL,
        `VOCE_INCASSO`           VARCHAR(5)      DEFAULT NULL,
        `LORDO_SOPHIA`           DECIMAL(30, 15) DEFAULT NULL,
        `LORDO_NDM`              DECIMAL(30, 15) DEFAULT NULL,
        `SEMAFORO`               BOOLEAN,
        `NETTO_SOPHIA`           DECIMAL(30, 15) DEFAULT NULL,
        `NETTO_NDM`              DECIMAL(30, 15) DEFAULT NULL,
        `PERC_AGGIO_NDM`         DECIMAL(30, 15) DEFAULT NULL,
        `NETTO_SOPHIA_ART_18`    DECIMAL(30, 15) DEFAULT NULL,
        `FLAG_MEGACONCERT`       BIT DEFAULT NULL,
        KEY `IDX_PERIODO` (`PERIODO`),
        KEY `IDX_DATA_CONTABILE_FATTURA` (`DATA_CONTABILE_FATTURA`),
        KEY `IDX_PERIODO_DATA_CONTABILE_FATTURA` (`PERIODO`, `DATA_CONTABILE_FATTURA`),
        KEY `IDX_NUMERO_FATTURA` (`NUMERO_FATTURA`),
        KEY `IDX_NUMERO_FATTURA_VOCE_INCASSO` (`NUMERO_FATTURA`, `VOCE_INCASSO`),
        KEY `IDX_PERIODO_NUMERO_FATTURA_VOCE_INCASSO` (`PERIODO`, `NUMERO_FATTURA`, `VOCE_INCASSO`),
        KEY `IDX_SEDE` (`SEDE`),
        KEY `IDX_AGENZIA` (`AGENZIA`),
        KEY `IDX_SEPRAG` (`SEPRAG`)
    ) COMMENT = 'vista materializzata per riconciliazione importi';
    TRUNCATE TABLE PERF_RICONC_MV;
    INSERT INTO PERF_RICONC_MV (SEDE, AGENZIA, SEPRAG, PERIODO, NUMERO_FATTURA,
                                DATA_CONTABILE_FATTURA, VOCE_INCASSO,
                                LORDO_SOPHIA, LORDO_NDM, SEMAFORO, NETTO_SOPHIA,
                                NETTO_NDM, PERC_AGGIO_NDM, NETTO_SOPHIA_ART_18, FLAG_MEGACONCERT)
    SELECT innerQ.SEDE,
           innerQ.AGENZIA,
           innerQ.SEPRAG,
           innerQ.CONTABILITA                      AS PERIODO,
           innerQ.NUMERO_FATTURA,
           DATA_CONTABILE_FATTURA                  AS DATA_CONTABILE_FATTURA,
           innerQ.VOCE_INCASSO                     AS VOCE_INCASSO,
           LORDO_SOPHIA,
           PERF_NDM_VOCE_FATTURA.IMPORTO_ORIGINALE AS LORDO_NDM,
           innerQ.SEMAFORO                         AS SEMAFORO,
           CASE
               WHEN (LORDO_SOPHIA IS NOT NULL AND AGGIO_SOPHIA IS NOT NULL)
                   THEN (LORDO_SOPHIA - AGGIO_SOPHIA)
               ELSE NULL END                       AS NETTO_SOPHIA,
           CASE
               WHEN (PERF_NDM_VOCE_FATTURA.IMPORTO_ORIGINALE IS NOT NULL AND
                     PERF_NDM_VOCE_FATTURA.IMPORTO_AGGIO IS NOT NULL) THEN (
                       PERF_NDM_VOCE_FATTURA.IMPORTO_ORIGINALE -
                       PERF_NDM_VOCE_FATTURA.IMPORTO_AGGIO)
               ELSE NULL END                       AS NETTO_NDM,
           PERF_NDM_VOCE_FATTURA.PERCENTUALE_AGGIO AS PERC_AGGIO_NDM,
           CASE
               WHEN (LORDO_SOPHIA IS NOT NULL AND AGGIO_SOPHIA IS NOT NULL AND
                     innerQ.IMPORTO_EX_ART_18 IS NOT NULL) THEN (
                       (LORDO_SOPHIA - AGGIO_SOPHIA) - innerQ.IMPORTO_EX_ART_18)
               ELSE NULL END                       AS NETTO_SOPHIA_ART_18,
               ma.FLAG_MEGACONCERT AS FLAG_MEGACONCERT
    FROM (SELECT PERF_EVENTI_PAGATI.CONTABILITA,
                 PERF_EVENTI_PAGATI.VOCE_INCASSO,
                 PERF_EVENTI_PAGATI.NUMERO_FATTURA,
                 CASE
                     WHEN MIN(PERF_EVENTI_PAGATI.QUADRATURA_NDM) = 1 THEN 1
                     ELSE 0 END                            AS SEMAFORO,
                 SUM(PERF_EVENTI_PAGATI.IMPORTO_DEM)       AS LORDO_SOPHIA,
                 SUM(PERF_EVENTI_PAGATI.IMPORTO_AGGIO)     AS AGGIO_SOPHIA,
                 SUM(PERF_EVENTI_PAGATI.IMPORTO_EX_ART_18) AS IMPORTO_EX_ART_18,
                 PERF_EVENTI_PAGATI.AGENZIA,
                 PERF_EVENTI_PAGATI.SEDE,
                 PERF_EVENTI_PAGATI.SEPRAG,
                 PERF_EVENTI_PAGATI.ID_EVENTO
          FROM PERF_EVENTI_PAGATI
          WHERE PERF_EVENTI_PAGATI.QUADRATURA_NDM IS NOT NULL
          GROUP BY PERF_EVENTI_PAGATI.CONTABILITA,
                   PERF_EVENTI_PAGATI.NUMERO_FATTURA,
                   PERF_EVENTI_PAGATI.VOCE_INCASSO) AS innerQ
             JOIN PERF_NDM_VOCE_FATTURA
                  ON (PERF_NDM_VOCE_FATTURA.NUMERO_FATTURA =
                      innerQ.NUMERO_FATTURA AND
                      PERF_NDM_VOCE_FATTURA.VOCE = innerQ.VOCE_INCASSO)
            LEFT JOIN PERF_MANIFESTAZIONE ma ON (innerQ.ID_EVENTO=ma.ID_EVENTO)
    GROUP BY innerQ.CONTABILITA, innerQ.NUMERO_FATTURA, innerQ.VOCE_INCASSO
    ORDER BY innerQ.CONTABILITA, innerQ.NUMERO_FATTURA,
             innerQ.VOCE_INCASSO;
END $$
DELIMITER ;
DROP EVENT IF EXISTS TEST_PERF_RICONC_MV;
